'use strict';

var a = angular.module('setup2FactorAuthApp')
    .controller('MainCtrl', function ( $window, $scope, $route, $location, Salt) {

	
		$('div#qrcode').hide();
		$('div#fail').hide();
		$('#btn-fail').hide();
		$('#btn-success').hide();
		
		$scope.accept = function(){
			 var options = {
				keyboard: false,
				backdrop: 'static',
				show: true
			}
            $('div#login').modal(options);
		}
		
		$scope.disable = function(){
			var options = {
				keyboard: false,
				backdrop: 'static',
				show: true
			}
            $('div#logind').modal(options);
		}

});

twoFactorAuthApp.controller('httpWarningCtrl', function( $scope, $location){

    var protocol = $location.protocol();

    if(protocol != 'https'){
        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }
        $('#httpwarning').modal(options);
        $('div#login').modal('hide');
        $('div#setup').modal('hide');
    }




});

twoFactorAuthApp.controller('loginCtrl', function( $scope, Auth, Salt){

    $scope.login = function(){
        var result = Auth.login($scope.lmasterPassword).then(function(resp){
			if(resp.response == 1){
				$('div#login').modal('hide');
				
				//generate salt
				Salt.generate($scope.lmasterPassword);
				
				$('div#setup').modal('show');
			}
        });


    }

	$scope.close = function(){
		$scope.lmasterPassword="";
		$('div#setup').modal('hide');
		$('div#login').modal('hide');
	}
});

twoFactorAuthApp.controller('logindCtrl', function( $scope, Auth, Salt){
	
    $scope.logind = function(){
        var result = Auth.login($scope.ldmasterPassword).then(function(resp){
			if(resp.response == 1){
				$('div#logind').modal('hide');
				
				//generate salt
				Salt.disable($scope.ldmasterPassword);
				
			}
        });


    }

	$scope.closed = function(){
		$scope.ldmasterPassword="";
		$('div#logind').modal('hide');
	}

	$scope.clearPwd = function(){
		$scope.ldmasterPassword="";
	}
});

twoFactorAuthApp.controller('setupCtrl', function( $scope, $window, Auth){

	$('div#qrcode').hide();
	$('div#fail').hide();
	
    $scope.done = function(){
        
		$('div#qrcode').hide();
		$('div#fail').hide();
		$('#btn-success').hide();
		$('#btn-fail').hide();
		$('div#setup').modal('hide');
    }

	$scope.reload = function(){
		$window.location.reload();
	}

});