'use strict';

var a = angular.module('setupApp')
    .controller('MainCtrl', function ( $window, $scope, $route, $location, Config) {

	$window.masterKey = '';
	$window.nonce = '';
	$window.nonce_error = 100;
	$window.config = {};
	
	var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
    }
		
	$scope.updateGCM = function(){

		var is_enabled = false;
		
		if($scope.gcmEnable || $scope.gcmEnable == "true")
			is_enabled=true;
			
		var is_locked = false;
		
		if($scope.lockRegId || $scope.lockRegId == "true")
			is_locked=true;
			
		var is_email = false;
		if($scope.isEmail || $scope.isEmail == "true")
			is_email=true;
			
		var result = Config.update_gcm($window.masterKey,$window.nonce,is_enabled?"y":"n",$scope.gcmSenderId,$scope.gcmAPIKey,is_locked?"y":"n",is_email?"y":"n",$scope.email).then(function(resp){

		});
	}
		
});
setupApp.controller('loginCtrl', function( $scope, $window, Auth, Config){

	$("div#two_factor").hide();

	var is_2_factor = Config.is2factor().then(function(resp){

        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }

		var result = resp.data;
		result = result.replace(/^[\r\n]+|\.|[\r\n]+$/g, "");
			
        if( (result === false || result == 'false')){
			
			$('div#two_factor').hide();
			$scope.twofactorCode='000000';
        }else{
			
			$('div#two_factor').show();

        }

		$('div#login').modal(options);
    });
	
    $scope.login = function(){
		
		
		var prefill_form = function(){

					for(var i = 0; i < $window.config.length; i++) {
						var obj = $window.config[i];
						if(obj.key == 'gcm_is_enabled' && (obj.value == "1" || obj.value == 1)){
							$scope.$parent.gcmEnable=true;
						}else if(obj.key == 'gcm_api_key'){
							$scope.$parent.gcmAPIKey=obj.value;
						}else if(obj.key == 'gcm_sender_id'){
							$scope.$parent.gcmSenderId=obj.value;
						}else if(obj.key == 'gcm_is_lock_reg_id' && (obj.value == "1" || obj.value == 1)){
							$scope.$parent.lockRegId=true;
						}else if(obj.key.substring(0,11) == 'gcm_reg_id_'){
							$scope.$parent.regId=obj.value;
						}else if(obj.key == 'gcm_email_reg_id_flag' && (obj.value == "1" || obj.value == 1)){
							$scope.$parent.isEmail=true;
						}else if(obj.key == 'gcm_email_reg_id'){
							$scope.$parent.email=obj.value;
						}
						
					}
		}
		
		Config.is2factor().then(function(resp){
			var result = resp.data;
			result = result.replace(/^[\r\n]+|\.|[\r\n]+$/g, "");
		
			if( (result === false || result == 'false')){
				result = Auth.login($scope.lmasterPassword).then(function(resp){
					var cfg = Config.get($window.masterKey,$window.nonce).then(function(resp){
						prefill_form();
					});
				});
			}else{
				result = Auth.two_factor($scope.lmasterPassword,$scope.twofactorCode).then(function(resp){
				
				
				
					var cfg = Config.get($window.masterKey,$window.nonce).then(function(){
						prefill_form();
					
					});
				
				});
			}
		});
    }


});
setupApp.controller('httpWarningCtrl', function( $scope, $location){

    var protocol = $location.protocol();

    if(protocol != 'https'){
        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }
        $('#httpwarning').modal(options);
        $('div#login').modal('hide');
        $('div#setup').modal('hide');
    }




});