<?php

class Category extends Base_Service
{


	function add($cat_name){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		
		$util = new UTIL();
		
		$cat_id = $util->gen_uuid();
		
		$db->execute("insert into Category (cat_id,cat_name) values ('" . $cat_id . "','" . mysql_real_escape_string($cat_name) . "')");
		
		// Close the connexion to the base:
		$db->close();
		
		return $cat_id;
	}

	function get($cat_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$cat_id = mysql_real_escape_string($cat_id);

		$cat_list = array();
		
		$db->query("select * from Category where cat_id = '" . $cat_id . "' order by cat_name asc");
		
		while ($row = $db->fetchNextObject()) {
			$new_row = array("cat_id" => $row->cat_id, "cat_name" => $row->cat_name);
			array_push($cat_list, $new_row);
		}
		
		$db->close();

		return $cat_list;
		
	}

	function list_cat(){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$cat_list = array();
		
		$db->query("select * from Category order by cat_name asc");
		
		while ($row = $db->fetchNextObject()) {
			$new_row = array("cat_id" => $row->cat_id, "cat_name" => $row->cat_name);
			array_push($cat_list, $new_row);
		}
		
		$db->close();

		return $cat_list;
		
	}

	/*
	        mode 1 - delete all password with the same category assigned
	        mode 2 - retain all password, transfer as 'Uncategorized'
	       mode 3 - retain all password, transfer to specify category.
	       */
	function delete($cat_id,$mode,$xferCatId = '00000000-0000-0000-0000-000000000000'){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $cat_id = mysql_real_escape_string($cat_id);

		// Check if category id existed
		$chk = $db->countOf("Category", "cat_id = '" . $cat_id . "'");
		
		if($chk == 0)
			return 12;
		/*
		TODO: transaction need
		*/
        if($mode == 1){
		    $sql = "delete from Password_Context where pwd_id in (select pwd_id from Password where pwd_cat = '" . $cat_id . "')";
		    $db->execute($sql);
        }

		$sql = "delete from Password where pwd_cat = '" . $cat_id . "'";

		if($mode > 1){
            $sql = "update Password set pwd_cat = '" . $xferCatId . "' where pwd_cat = '" . $cat_id . "'";
		}

        $db->execute($sql);

		$db->execute("delete from Category where cat_id = '" . $cat_id . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}
	
	function update($cat_id,$cat_name){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $cat_id = mysql_real_escape_string($cat_id);
        $cat_name = mysql_real_escape_string($cat_name);

		// Check if category id existed
		$chk = $db->countOf("Category", "cat_id = '" . $cat_id . "'");
		
		if($chk == 0)
			return 12;
			
		$db->execute("update Category set cat_name = '" . $cat_name . "' where cat_id = '" . $cat_id . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}
	
	

}
?>