<?php



class Config extends Base_Service
{


	function is_inited(){
	
        $result = false;

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select count(*) as cno from Config where config_key = 'master_key' or config_key = 'encrypt_key'";
		


		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        if($cnt == 2)
            return true;

		return false;
		
	}

	function get_encryption_key($master){
		$verno = $this->verify();
		
		if(! ($verno === true) || empty($master))
			return $verno;
		
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$master = mysql_real_escape_string($master);
		
		$sql = "select config_value from Config where config_key = 'encrypt_key'";
		
		$encrypted_key = "";

		$db->query($sql);

		while ($row = $db->fetchNextObject()) {
			$encrypted_key = $row->config_value;
			break;
		}

		$db->close();
		
		$options = Array(
            'encryption_key' => $master,
            'data_to_decrypt' => $encrypted_key
        );

        $aes = new AES($options);

        $dpass = $aes->decrypt();

		return $dpass;
		
	}
	
    function save($master,$encKey){

        $verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

        if($this->is_inited())
            return 11;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $master = mysql_real_escape_string($master);
        $encKey = mysql_real_escape_string($encKey);



        $options = Array(
            'encryption_key' => $master,
            'data_to_encrypt' => "password"
                    		);

        $aes = new AES($options);

        $encryptedMaster = $aes->encrypt();

        $options = Array(
            'encryption_key' => $master,
            'data_to_encrypt' => $encKey
                    		);

        $aes = new AES($options);

        $encryptedKey = $aes->encrypt();






        $del_sql = "delete from Config where config_key = 'master_key' or config_key = 'encrypt_key'";

        $db->execute($del_sql);

		$util = new UTIL();

        $newkey = $util->gen_uuid();

        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','master_key','" . $encryptedMaster . "')");

        $newkey = $util->gen_uuid();

        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','encrypt_key','" . $encryptedKey . "')");


		$db->close();

		return true;

	}
	
	function update_master_pwd($encKey,$newMaster){

		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $newMaster = mysql_real_escape_string($newMaster);
        $encKey = mysql_real_escape_string($encKey);

		
		

        $options = Array(
            'encryption_key' => $newMaster,
            'data_to_encrypt' => "password"
                    		);

        $aes = new AES($options);

        $encryptedMaster = $aes->encrypt();

        $options = Array(
            'encryption_key' => $newMaster,
            'data_to_encrypt' => $encKey
                    		);

        $aes = new AES($options);

        $encryptedKey = $aes->encrypt();






        $del_sql = "delete from Config where config_key = 'master_key' or config_key = 'encrypt_key'";

        $db->execute($del_sql);

		$util = new UTIL();

        $newkey = $util->gen_uuid();

        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','master_key','" . $encryptedMaster . "')");

        $newkey = $util->gen_uuid();

        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','encrypt_key','" . $encryptedKey . "')");


		$db->close();

		return true;

	}
	
	function gen_2_factor_key($master,$encKey,$initKey){

	
        $verno = $this->verify();

		if((! ($verno === true)) || empty($master) || empty($encKey) || empty($initKey))
			return $verno;
		
        if(! $this->is_inited())
            return false;
		
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		$master = mysql_real_escape_string($master);
        $encKey = mysql_real_escape_string($encKey);

        $options = Array(
            'encryption_key' => $encKey,
            'data_to_encrypt' => $initKey
                    		);

        $aes = new AES($options);

        $encryptedKey = $aes->encrypt();	
		
        $del_sql = "delete from Config where config_key = '2_factor_key'";

        $db->execute($del_sql);

		$util = new UTIL();
		
        $newkey = $util->gen_uuid();

        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','2_factor_key','" . $encryptedKey . "')");

		$db->close();

		return true;

	}
	
	function is_2_factor(){
	
        $result = false;

		$verno = $this->verify();


		if(! ($verno === true))
			return $verno;


			
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select count(*) as cno from Config where config_key = '2_factor_key'";
		


		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        if($cnt == 1)
            return true;

		return false;
		
	}
	
	function disable_2_factor_key(){

	
        $verno = $this->verify();

		if((! ($verno === true)))
			return $verno;
		
        if(! $this->is_inited())
            return false;
		
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
        $del_sql = "delete from Config where config_key = '2_factor_key'";

        $db->execute($del_sql);

		$db->close();

		return true;

	}
	
	
	function create_nonce(){

	
        $verno = $this->verify();

		if((! ($verno === true)))
			return $verno;
		
        if(! $this->is_inited())
            return false;
		
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
        $del_sql = "delete from Config where config_key = 'nonce' or config_key = 'nonce_valid_until'";

        $db->execute($del_sql);

		$util = new UTIL();
		
        $newkey = $util->gen_uuid();
		$nonce = $util->gen_nonce();
		
        $db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','nonce','" . $nonce . "')");
		
		$newkey = $util->gen_uuid();
		
		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','nonce_valid_until',unix_timestamp()+900)");

		$db->close();

		return $nonce;

	}
	
	
	function update_gcm($encKey,$enable,$senderId,$apiKey,$isLockRegId,$isEmail,$email){


		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        
        $encKey = mysql_real_escape_string($encKey);
		
		$encryptedSenderId = "";
		if(! empty($senderId)){
			$senderId = mysql_real_escape_string($senderId);
			$options = Array(
            'encryption_key' => $encKey,
            'data_to_encrypt' => $senderId
                    		);

			$aes = new AES($options);

			$encryptedSenderId = $aes->encrypt();
		}
		$encryptedAPIKey = "";
		if(! empty($apiKey)){
			$apiKey = mysql_real_escape_string($apiKey);	

			$options = Array(
				'encryption_key' => $encKey,
				'data_to_encrypt' => $apiKey
			);

			$aes = new AES($options);

			$encryptedAPIKey = $aes->encrypt();
		}
        

        $del_sql = "delete from Config where config_key = 'gcm_sender_id'";
		$del_sql.= " or config_key = 'gcm_api_key' or config_key = 'gcm_is_enabled'";
		$del_sql.= " or config_key = 'gcm_is_lock_reg_id'";
		$del_sql.= " or config_key = 'gcm_email_reg_id_flag'";
		$del_sql.= " or config_key = 'gcm_email_reg_id'";

        $db->execute($del_sql);

		$util = new UTIL();

		if(! empty($senderId)){
			$newkey = $util->gen_uuid();

			$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_sender_id','" . $encryptedSenderId . "')");

		}
		
		if(! empty($apiKey)){
			$newkey = $util->gen_uuid();

			$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_api_key','" . $encryptedAPIKey . "')");
		}

		
		$is_enabled = 0;
		if($enable)
			$is_enabled = 1;
			
		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_is_enabled','" . $is_enabled . "')");

		$is_locked = 0;
		if($isLockRegId)
			$is_locked = 1;
			
		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_is_lock_reg_id','" . $is_locked . "')");

		$is_email = 0;
		if($isEmail)
			$is_email = 1;
			
		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_email_reg_id_flag','" . $is_email . "')");

		if(! empty($email)){
			$newkey = $util->gen_uuid();

			$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_email_reg_id','" . $email . "')");

		}
		
		$db->close();

		return true;

	}
	
	function update_reg_id($encKey,$regId,$deviceId){


		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey) || empty($regId) || empty($deviceId))
			return $verno;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        
        $encKey = mysql_real_escape_string($encKey);
		$regId = mysql_real_escape_string($regId);
		$deviceId = mysql_real_escape_string($deviceId);

		$encryptedRegId = "";
		$encryptedDeviceId = "";
		
		$options = Array(
           'encryption_key' => $encKey,
           'data_to_encrypt' => $regId
        );

		$aes = new AES($options);

		$encryptedRegId = $aes->encrypt();
		

		$options = Array(
           'encryption_key' => $encKey,
           'data_to_encrypt' => $deviceId
        );

		$aes = new AES($options);

		$encryptedDeviceId = $aes->encrypt();
		
        $del_sql = "delete from Config where config_key like 'gcm_reg_id_%' or config_key like 'gcm_device_id_%'";

        $db->execute($del_sql);

		$util = new UTIL();
		$nonce = $util->gen_nonce();
		
		
		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_reg_id_" . $nonce . "','" . $encryptedRegId . "')");

		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','gcm_device_id_" . $nonce . "','" . $encryptedDeviceId . "')");
			
		$db->close();

		return true;

	}
	function get($encKey){

		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

		$field_need_decrypt = array('gcm_sender_id','gcm_api_key','gcm_reg_id_');
		
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$encKey = mysql_real_escape_string($encKey);

		
		$sql = "select config_key,config_value from Config where config_key <> 'master_key' and ";
		$sql.= "config_key <> 'nonce_valid_until' and config_key <> '2_factor_key' and config_key <> 'nonce' and ";
		$sql.= "config_key <> 'encrypt_key'";

		$db->query($sql);

		$config_list = array();
		
		while ($row = $db->fetchNextObject()) {
			$cvalue = $row->config_value;
			foreach ($field_need_decrypt as &$value) {
				if (strpos($row->config_key,$value) !== false) {
				
				//if($value == $row->config_key){
					

					$options = Array(
								'encryption_key' => $encKey,
								'data_to_decrypt' => $cvalue
								);

					$aes = new AES($options);

					$cvalue = $aes->decrypt();

					break;
				}
			}
			
			$new_row = array("key" => $row->config_key, "value" => $cvalue);
			
			array_push($config_list, $new_row);
		}
		
		$db->close();

        

		return $config_list;

	}
	
	function get_gcm_sender_id($encKey){

		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

		//$field_need_decrypt = array('gcm_sender_id','gcm_api_key');
		
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$encKey = mysql_real_escape_string($encKey);

		
		$sql = "select config_value from Config where config_key = 'gcm_sender_id'";
		
		$db->query($sql);
		
		$senderId = "";
		
		while ($row = $db->fetchNextObject()) {
			$senderId = $row->config_value;
			break;
		}
		
		$db->close();

        if($senderId != ""){
			$options = Array(
				'encryption_key' => $encKey,
				'data_to_decrypt' => $senderId
			);

			$aes = new AES($options);

			$senderId = $aes->decrypt();
		}

		return $senderId;

	}
	function get_gcm_api_key($encKey){

		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

		//$field_need_decrypt = array('gcm_sender_id','gcm_api_key');
		
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$encKey = mysql_real_escape_string($encKey);

		
		$sql = "select config_value from Config where config_key = 'gcm_api_key'";
		
		$db->query($sql);
		
		$api_key = "";
		
		while ($row = $db->fetchNextObject()) {
			$api_key = $row->config_value;
			break;
		}
		
		$db->close();

        if($api_key != ""){
			$options = Array(
				'encryption_key' => $encKey,
				'data_to_decrypt' => $api_key
			);

			$aes = new AES($options);

			$api_key = $aes->decrypt();
		}

		return $api_key;

	}
	function count_reg_id(){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

				
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$sql = "select count(*) as cno from Config where config_key like 'gcm_reg_id_%'";

		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        return $cnt;

	}
	
	function is_gcm_enabled(){
	
        $result = false;

		$verno = $this->verify();


		if(! ($verno === true))
			return $verno;


			
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select count(*) as cno from Config where config_key = 'gcm_is_enabled' and config_value='1'";
		


		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        if($cnt > 0)
            return true;

		return false;
		
	}
	
	function get_gcm_first_reg_id($encKey){

		$verno = $this->verify();

		if(! ($verno === true) || empty($encKey))
			return $verno;

	
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$encKey = mysql_real_escape_string($encKey);

		
		$sql = "select config_value from Config where config_key like 'gcm_reg_id_%' order by config_id limit 1;";
		
		$db->query($sql);
		
		$reg_id = "";
		
		while ($row = $db->fetchNextObject()) {
			$reg_id = $row->config_value;
			break;
		}
		
		$db->close();

        if($reg_id != ""){
			$options = Array(
				'encryption_key' => $encKey,
				'data_to_decrypt' => $reg_id
			);

			$aes = new AES($options);

			$reg_id = $aes->decrypt();
		}

		return $reg_id;

	}
	
	function is_lock_reg_id(){
	
        $result = false;

		$verno = $this->verify();


		if(! ($verno === true))
			return $verno;


			
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select count(*) as cno from Config where config_key = 'gcm_is_lock_reg_id' and config_value='1'";
		


		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        if($cnt > 0)
            return true;

		return false;
		
	}
	
	function is_email_reg_id(){
	
        $result = false;

		$verno = $this->verify();


		if(! ($verno === true))
			return $verno;


			
		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select count(*) as cno from Config where config_key = 'gcm_email_reg_id_flag' and config_value='1'";
		


		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

		$db->close();

        if($cnt > 0)
            return true;

		return false;
		
	}
	
	
	function get_gcm_email_reg_id(){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

	
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$sql = "select config_value from Config where config_key = 'gcm_email_reg_id' order by config_id limit 1;";
		
		$db->query($sql);
		
		$reg_id = "";
		
		while ($row = $db->fetchNextObject()) {
			$reg_id = $row->config_value;
			break;
		}
		
		$db->close();

		return $reg_id;

	}
}


?>