<?php



class Password extends Base_Service
{


	function get($pwd_id,$enc_key){
	

		$verno = $this->verify();

		if(! ($verno === true) || empty($enc_key))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$pwd_list = array();
		
		$sql = "select a.*,b.cat_name from Password a, Category b where a.pwd_cat = b.cat_id and a.pwd_id = '" . mysql_real_escape_string($pwd_id) . "'";
		
		

		$db->query($sql);
		
		while ($row = $db->fetchNextObject()) {
		    $options = Array(
                			'encryption_key' => $enc_key,
                			'data_to_decrypt' => $row->pwd_pwd
            );

            $aes = new AES($options);

            $dpass = $aes->decrypt();

            if(!empty($row->pwd_notes)){
                $options = Array(
                                'encryption_key' => $enc_key,
                                'data_to_decrypt' => $row->pwd_notes
                );

                $aes = new AES($options);

                $dnotes = $aes->decrypt();
            }else{
                $dnotes = $row->pwd_notes;
            }

			$new_row = array("pwd_id" => $row->pwd_id, "pwd_cat" => $row->pwd_cat, "cat_name" => $row->cat_name, "pwd_title" => $row->pwd_title, "pwd_login" => $row->pwd_login, "pwd_pwd" => $dpass, "pwd_url" => $row->pwd_url, "pwd_notes" => $dnotes);
			array_push($pwd_list, $new_row);
		}
		
		$db->close();

		return $pwd_list;
		
	}
	function add( $raw_pwd, $cat_id, $title, $login, $url, $notes, $tags, $enc_key){



		$verno = $this->verify();

		if(! ($verno === true) || empty($enc_key))
			return $verno;

	    $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

	    $raw_pwd = mysql_real_escape_string($raw_pwd);
	    $cat_id = mysql_real_escape_string($cat_id);
	    $title = mysql_real_escape_string($title);
	    $login = mysql_real_escape_string($login);
	    $url = mysql_real_escape_string($url);
	    $notes = mysql_real_escape_string($notes);
	    $tags = $this->mysql_real_escape_array($tags);
	    $enc_key = mysql_real_escape_string($enc_key);

		$url_sql = "";
		
		if(empty($url)){
			$url_sql = "null";
		}else{
			$url_sql = "'" . $url . "'";
		}
	
		if(empty($notes)){
			$notes_sql = "null";
		}else{
		    $options = Array(
        			'encryption_key' => $enc_key,
        			'data_to_encrypt' => $notes
        	);

        	$aes = new AES($options);

            $enotes = $aes->encrypt();
			$notes_sql = "'" . $enotes . "'";
		}
	
		$options = Array(
			'encryption_key' => $enc_key,
			'data_to_encrypt' => $raw_pwd
		);

		$aes = new AES($options);

        $epass = $aes->encrypt();



		// Check if Category id existed
		$chk = $db->countOf("Category", "cat_id = '" . $cat_id . "'");
		
		if($chk == 0)
			return 12;
			
		$util = new UTIL();
		
		$newkey = $util->gen_uuid();
		
		$db->execute("insert into Password (pwd_id,pwd_pwd,pwd_cat,pwd_title,pwd_login,pwd_url,pwd_notes) values ('" . $newkey . "','" . $epass . "','" . $cat_id . "','" . $title . "','" . $login . "',"  . $url_sql . "," . $notes_sql . ")");

        //password entry created, now add tags
        if(!(empty($tags))){

            foreach($tags as $tag){


                //check if ctx_name already existed, if not, create it

                $sql = "select * from Context where ctx_name = '" . $tag . "'";

                $db->query($sql);

                $result = false;

                while ($row = $db->fetchNextObject()) {
                    $result = $row->ctx_id;
                    break;
                 }

                if($result === FALSE){

                    //not existed, create new context record
                    $new_id = $util->gen_uuid();

                    $db->execute("insert into Context (ctx_id,ctx_name) values ('" . $new_id . "','" . $tag . "')");
                    $result = $new_id;

                }


                $db->execute("insert into Password_Context (pc_id,pwd_id,ctx_id) values ('" . $util->gen_uuid() . "','" . $newkey . "','" . $result . "')");

            }
        }

		// Close the connexion to the base:
		$db->close();

		return $newkey;

	}


	//function list_pwd($cat_id = '0', $get_context = false, $enc_key, $offset = 0, $pageSize = 50){
    function list_pwd($cat_id = '0', $get_context = false, $enc_key){


		$verno = $this->verify();

		if(! ($verno === true) || empty($enc_key))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$cat_id = mysql_real_escape_string($cat_id);

		$pwd_list = array();
		
		$sql = "select a.*,b.cat_name from Password a, Category b";

        $sql .= " where a.pwd_cat = b.cat_id";

		if((! empty($cat_id)) and $cat_id <> '0')
			$sql .= " and a.pwd_cat = '" . $cat_id . "'";

        $sql .= " order by a.pwd_title asc";

        if($get_context){
            $before_sql = "select e.*, group_concat(f.ctx_name SEPARATOR ' ') as ctx_name from (";
            $before_sql.= "select c.*, d.ctx_id from (";

            $after_sql = ") c left join Password_Context d on c.pwd_id = d.pwd_id) e ";
            $after_sql.= "left join  Context f on e.ctx_id = f.ctx_id group by e.pwd_id order by e.pwd_title asc";

            $sql = $before_sql . $sql . $after_sql;
        }



        //$sql .= " limit $offset, $pageSize";


		$db->query($sql);
		
		while ($row = $db->fetchNextObject()) {


		    $options = Array(
        			'encryption_key' => $enc_key,
        			'data_to_decrypt' => $row->pwd_pwd
        		);

        	$aes = new AES($options);

            $dpass = $aes->decrypt();



            if(!empty($row->pwd_notes)){
                $options = Array(
                    			'encryption_key' => $enc_key,
                    			'data_to_decrypt' => $row->pwd_notes
                    		);
        	    $aes = new AES($options);

                $dnotes = $aes->decrypt();
            }else{
                $dnotes = $row->pwd_notes;
            }

			$new_row = array(
				 "pwd_id" => $row->pwd_id,
				 "pwd_pwd" => $dpass,
				 "pwd_cat" => $row->pwd_cat,
				 "pwd_icon" => $row->pwd_icon,
				 "pwd_title" => $row->pwd_title,
				 "pwd_login" => $row->pwd_login,
				 "pwd_url" => $row->pwd_url,
				 "pwd_notes" => $dnotes,
				 "cat_name" => $row->cat_name,
				 "ctx_name" => $row->ctx_name
			);
			array_push($pwd_list, $new_row);
		}
		
		$db->close();


		return $pwd_list;
		
	}
	
	function delete($pwd_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $pwd_id = mysql_real_escape_string($pwd_id);

		// Check if context id existed
		$chk = $db->countOf("Password", "pwd_id = '" . $pwd_id . "'");
		
		if($chk == 0)
			return 12;

	    $db->execute("delete from Password_Context where pwd_id = '" . $pwd_id . "'");
		$db->execute("delete from Password where pwd_id = '" . $pwd_id . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}
	
	function update($pwd_id, $raw_pwd, $cat_id, $title, $login, $url, $notes,$enc_key){
		
		$verno = $this->verify();

		if(! ($verno === true) || empty($enc_key))
			return $verno;


		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $pwd_id = mysql_real_escape_string($pwd_id);
        $raw_pwd = mysql_real_escape_string($raw_pwd);
        $cat_id = mysql_real_escape_string($cat_id);
        $title = mysql_real_escape_string($title);
        $login = mysql_real_escape_string($login);
        $url = mysql_real_escape_string($url);
        $notes = mysql_real_escape_string($notes);
        $enc_key = mysql_real_escape_string($enc_key);

		// Check if password id existed
		$chk = $db->countOf("Password", "pwd_id = '" . $pwd_id . "'");

		if($chk == 0)
			return 12;

		// Check if category id existed
		$chk = $db->countOf("Category", "cat_id = '" . $cat_id . "'");
		
		if($chk == 0)
			return 13;


		$options = Array(
			'encryption_key' => $enc_key,
			'data_to_encrypt' => $raw_pwd
		);


		$aes = new AES($options);

		$epass = $aes->encrypt();

		$url_sql = "null";
		$notes_sql = "null";
		
		if(! empty($url))
			$url_sql = "'" . $url . "'";
		if(! empty($notes)){
            $options = Array(
            			'encryption_key' => $enc_key,
            			'data_to_encrypt' => $notes
            );


            $aes = new AES($options);

            $enotes = $aes->encrypt();
			$notes_sql = "'" . $enotes . "'";
        }

		$update_sql  = "update Password set pwd_pwd = '" . $epass . "',";
		$update_sql .= "pwd_cat = '" . $cat_id . "', pwd_title = '" . $title . "',";
		$update_sql .= "pwd_login = '" . $login . "', ";
		$update_sql .= "pwd_url = " . $url_sql . ", pwd_notes = " . $notes_sql . " where pwd_id = '" . $pwd_id . "'";


		$db->execute($update_sql);
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}

	function list_pwd_by_ctx($ctx_id = '0', $get_context, $enc_key){
	
		$verno = $this->verify();

		if(! ($verno === true) || empty($enc_key))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$ctx_id = mysql_real_escape_string($ctx_id);

		$pwd_list = array();
		
		$sql = "select a.*,b.ctx_name,d.cat_name from Password a, Context b, Password_Context c, Category d where a.pwd_id = c.pwd_id and a.pwd_cat = d.cat_id";
		
		if((! empty($ctx_id)) and $ctx_id <> '0')
			$sql .= " and c.ctx_id = '" . $ctx_id . "' and b.ctx_id = '" . $ctx_id . "'";

        $sql .= " order by a.pwd_title asc";

        if($get_context){
            $before_sql = "select g.*, group_concat(h.ctx_name SEPARATOR ' ') as ctx_name from (";
            $before_sql.= "select e.*, f.ctx_id from (";

            $after_sql = ") e left join Password_Context f on e.pwd_id = f.pwd_id) g ";
            $after_sql.= "left join  Context h on g.ctx_id = h.ctx_id group by g.pwd_id order by g.pwd_title asc";

            $sql = $before_sql . $sql . $after_sql;
        }



		$db->query($sql);
		
		while ($row = $db->fetchNextObject()) {

            $options = Array(
        			'encryption_key' => $enc_key,
        			'data_to_decrypt' => $row->pwd_pwd
        		);

        	$aes = new AES($options);

            $dpass = $aes->decrypt();

            if(!empty($row->pwd_notes)){
                $options = Array(
                        'encryption_key' => $enc_key,
                        'data_to_decrypt' => $row->pwd_notes
                    );

        	    $aes = new AES($options);

                $dnotes = $aes->decrypt();
            }else{
                $dnotes = $row->pwd_notes;
            }

			$new_row = array(
				"pwd_id" => $row->pwd_id, 
				"pwd_pwd" => $dpass,
				"pwd_cat" => $row->pwd_cat, 
				"pwd_icon" => $row->pwd_icon, 
				"pwd_title" => $row->pwd_title,
				"pwd_login" => $row->pwd_login,
				"pwd_url" => $row->pwd_url,
				"pwd_notes" => $dnotes,
				"cat_name" => $row->cat_name, 
				"ctx_name" => $row->ctx_name
				
				
			);
			array_push($pwd_list, $new_row);
		}
		
		$db->close();

		return $pwd_list;
		
	}


	function search($keyword, $get_context = false, $enc_key){

    		$verno = $this->verify();

    		if(! ($verno === true))
    			return $verno;

            if(empty($keyword) || empty($enc_key))
                return false;

    		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

            $keyword = mysql_real_escape_string($keyword);
            $enc_key = mysql_real_escape_string($enc_key);

    		$pwd_list = array();

    		$sql = "select a.*,b.cat_name from Password a, Category b";

            $sql .= " where a.pwd_cat = b.cat_id and (a.pwd_title like '%$keyword%' or a.pwd_url like '%$keyword%' or a.pwd_notes like '%$keyword%' or b.cat_name like '%$keyword%') order by a.pwd_title asc";



            if($get_context){
                $before_sql = "select e.*, group_concat(f.ctx_name SEPARATOR ' ') as ctx_name from (";
                $before_sql.= "select c.*, d.ctx_id from (";

                $after_sql = ") c left join Password_Context d on c.pwd_id = d.pwd_id) e ";
                $after_sql.= "left join  Context f on e.ctx_id = f.ctx_id group by e.pwd_id order by e.pwd_title asc";

                $sql = $before_sql . $sql . $after_sql;
            }





    		$db->query($sql);

    		while ($row = $db->fetchNextObject()) {


    		    $options = Array(
            			'encryption_key' => $enc_key,
            			'data_to_decrypt' => $row->pwd_pwd
            		);

            	$aes = new AES($options);

                $dpass = $aes->decrypt();

                if(!empty($row->pwd_notes)){
                    $options = Array(
                            'encryption_key' => $enc_key,
                            'data_to_decrypt' => $row->pwd_notes
                        );

                    $aes = new AES($options);

                    $dnotes = $aes->decrypt();
                }else{
                    $dnotes = $row->pwd_notes;
                }
    			$new_row = array(
    				 "pwd_id" => $row->pwd_id,
    				 "pwd_pwd" => $dpass,
    				 "pwd_cat" => $row->pwd_cat,
    				 "pwd_icon" => $row->pwd_icon,
    				 "pwd_title" => $row->pwd_title,
    				 "pwd_login" => $row->pwd_login,
    				 "pwd_url" => $row->pwd_url,
    				 "pwd_notes" => $dnotes,
    				 "cat_name" => $row->cat_name,
    				 "ctx_name" => $row->ctx_name
    			);
    			array_push($pwd_list, $new_row);
    		}

    		$db->close();


    		return $pwd_list;

    }
}
?>