<?php

//Delete Category by Category ID
$app->delete('/category/:id/:mode/:xferCatId', function ($id,$mode,$xferCatId) use ($app) {

    $v	= $app->request()->delete() ;
    $json= $v['json'];

	$error = array();

	check_json($json);

	$param = json_decode($json);

	if($mode <> "1" && $mode <> "2" && $mode <> "3"){
		missing_parameter();
		die;
	}
	
	if($id == "00000000-0000-0000-0000-000000000000"){
		$error = array('response' => 0, 'err_code' => 2, 'err_desc' => 'Cannot delete system category.');

		echo json_encode($error);
		die;
	}
	
	$cat = new Category();

	$param_name = array('p','n');

	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
	
		$result = $cat->delete($id,$mode,$xferCatId);

		if($result === true)
			$error = array('response' => 1, 'err_code' => 0);
		else
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Delete category failed');
	}else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}
    
	echo json_encode($error);
    
});
?>
