<?php
//List Password
$app->post('/setup/gcm/save', function () {

    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$config = new Config();

	$param = json_decode($json);

	$param_name = array('p','n','e');
	
	$login_result = login($param,$param_name);

	if($login_result === true){	
		$enc_key = get_encryption_key($param->{'p'});
		
		$is_enabled = false;
		if($param->{'e'} == "Y" ||  $param->{'e'} == "y")
			$is_enabled = true;
		
		$is_lock_reg_id = false;
		if($param->{'l'} == "Y" ||  $param->{'l'} == "y")
			$is_lock_reg_id = true;
		
		$is_email_reg_id = false;
		if($param->{'a'} == "Y" ||  $param->{'a'} == "y")
			$is_email_reg_id = true;
			
		$result = $config->update_gcm($enc_key,$is_enabled, $param->{s}, $param->{'k'}, $is_lock_reg_id,$is_email_reg_id , $param->{'b'});


		if($result === true){
			$error = array('response' => 1, 'err_code' => 0, 'pwd_id' => $result);
		}else{
			$error = array('response' => 0, 'err_code' => 0, 'err_desc' => "Failed to update gcm setting.");
		}
	}else{

		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}
    echo json_encode($error);
});
?>