<?php


//Delete Context by Context ID
$app->delete('/context/:id', function ($id) use ($app) {

    $v	= $app->request()->delete() ;
    $json= $v['json'];

    $error = array();

    check_json($json);

    $param = json_decode($json);

	if(empty($id)){
		missing_parameter();
		die;
	}
	
	$param_name = array('p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
	
   	    $ctx = new Context();

        $result = $ctx->delete($id);

        if($result === true)
            $error = array('response' => 1, 'err_code' => 0);
        else
            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Delete context failed');

	}else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}

	
	echo json_encode($error);
});
?>