<?php
//Add Password
$app->post('/password', function () {

	sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];
	
	$error = array();

	check_json($json);
	
	$password = new Password();
	
	$param = json_decode($json);

	$param_name = array('k','p','n','c','t','l');

	$login_result = login($param,$param_name);
	
	
	if($login_result === true){

		$enc_key = get_encryption_key($param->{'p'});

		$result = $password->add($param->{'k'},$param->{'c'},$param->{'t'},$param->{'l'},$param->{'u'},$param->{'o'},$param->{'tags'},$enc_key);

		if(empty($result))
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Add password failed');
		else
			$error = array('response' => 1, 'err_code' => 0, 'pwd_id' => $result);
	}else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}

	echo json_encode($error);
	

});


?>