<?php
//Delete Password by Password ID
$app->delete('/password/:id', function ($id) use ($app) {

    $v	= $app->request()->delete() ;
    $json= $v['json'];

    $error = array();

    check_json($json);

    $param = json_decode($json);

	$param_name = array('p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
        //first retrieve a list of tags of the password for cache invalidation
        $pwd_ctx = new Password_Context();
        $tags = $pwd_ctx->list_ctx($id);

        $password = new Password();

        $result = $password->delete($id);

        if($result === true)
            $error = array('response' => 1, 'err_code' => 0, 'tags' => $tags);
        else
            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Delete password failed');
    }else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
    }
	
	echo json_encode($error);
});
?>