<?php
//Update Password by Password ID
$app->put('/password/:id', function ($id) use ($app) {

	$v = $app->request()->put();

	$json = $v['json'];

	$error = array();

	check_json($json);

	$password = new Password();

	$param = json_decode($json);

	$param_name = array('c','p','n','t','l','k');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
	
		$enc_key = get_encryption_key($param->{'p'});

	    $result = $password->update($id,$param->{'k'},$param->{'c'},$param->{'t'},$param->{'l'},$param->{'u'},$param->{'o'},$enc_key);

        if($result === true)
            $error = array('response' => 1, 'err_code' => 0);
        else
            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Update password failed');

    }else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
    }
	 echo json_encode($error);
});
?>