<?php


//Delete Password Context by Password ID and Context ID
$app->delete('/password/:pid/context/:cid', function ($pid, $cid) use ($app) {


	$v	= $app->request()->delete() ;
    $json= $v['json'];

	$error = array();

	check_json($json);

	$param = json_decode($json);
	
	if(empty($pid) || empty($cid)){
		missing_parameter();
		die;
	}
	
	$param_name = array('p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){

		$pwd_ctx = new Password_Context();

		$result = $pwd_ctx->delete($pid,$cid);

		if($result === true)
			$error = array('response' => 1, 'err_code' => 0);
		else
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Delete password context failed');
	}else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
    }
	echo json_encode($error);
});
?>