<?php
//Generate initial key for two factor
$app->post('/two_factor_key/disable', function () {

    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$auth = new Auth();

	$param = json_decode($json);

	if(
		empty($param->{'p'})
	){
		missing_parameter();
		die;
	}

	$result = $auth->login($param->{'p'});


	if($result === true){
		
	    $config = new Config();
		$result = $config->disable_2_factor_key();
		
		if($result === true)
			$error = array('response' => 1, 'err_code' => 0);
		else
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Failed to disable 2 factor authentication');
	}else{

            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'login failed');
     }
    echo json_encode($error);

});
?>