<?php



class Auth extends Base_Service
{


	function login($master){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
        $master=mysql_real_escape_string($master);

		$sql = "select * from Config where config_key = 'master_key'";

		$db->query($sql);

		$encrypted_master = "";

		while ($row = $db->fetchNextObject()) {
		    $encrypted_master = $row->config_value;
		    break;
		}

		$db->close();

        if(empty($encrypted_master) || $encrypted_master == "")
            return false;

         $options = Array(
                     'encryption_key' => $master,
                     'data_to_encrypt' => "password"
                             		);

        $aes = new AES($options);
        $dbencrypted_master = $aes->encrypt();

        if($encrypted_master == $dbencrypted_master)
            return true;
		return false;

	}

	function verify_code($encKey,$code){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
        $encKey=mysql_real_escape_string($encKey);

		$sql = "select * from Config where config_key = '2_factor_key'";

		$db->query($sql);

		$encrypted_2factor_key = "";

		while ($row = $db->fetchNextObject()) {
		    $encrypted_2factor_key = $row->config_value;
		    break;
		}
		
		$db->close();

		if(empty($encrypted_2factor_key) || $encrypted_2factor_key == "")
            return false;

		$two_factor_key = "";
        $options = Array(
            'encryption_key' => $encKey,
            'data_to_decrypt' => $encrypted_2factor_key
        );

        $aes = new AES($options);
        $two_factor_key = $aes->decrypt();
		
		//$TimeStamp	  = Google2FA::get_timestamp();
		//$secretkey 	  = Google2FA::base32_decode($two_factor_key);	// Decode it into binary
		//$otp       	  = Google2FA::oath_hotp($secretkey, $TimeStamp);	// Get current token

		$result  = Google2FA::verify_key($two_factor_key, $code);

		return $result;
	}
	
	function verify_nonce($nonce){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$nonce=mysql_real_escape_string($nonce);
		
		$sql = "select count(*) as cno from Config where config_key = 'nonce' and config_value ='" . $nonce . "'";

		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}

        if($cnt != 1){
			$db->close();
            return false;
		}
		$sql = "select count(*) as cno from Config where config_key = 'nonce_valid_until' and (config_value + 900) > unix_timestamp()";
		
		
		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}
		
		if($cnt != 1){
			$db->close();
            return false;
		}
		
		//update nonce
		$sql = "update Config  set config_value = unix_timestamp()+900 where config_key = 'nonce_valid_until'";

		$db->execute($sql);
		
		$db->close();

		return true;
	}
	
	function get_fail_count(){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

	
        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		
		
		$sql = "select count(config_value) as cno from Config where config_key = 'login_fail_timestamp' ";
		$sql.= " and (config_value + 900) > unix_timestamp()";
		
		$db->query($sql);

		$cnt = 0;
		while ($row = $db->fetchNextObject()) {
		    $cnt = $row->cno;
		    break;
		}
		
		if($cnt < 1){
			$db->close();
			return $cnt;
		}
		
		$sql = "select config_value from Config where config_key = 'login_fail_count'";
		
		$db->query($sql);
		
		$count = "0";
		
		while ($row = $db->fetchNextObject()) {
			$count = $row->config_value;
			break;
		}
		
		$db->close();
		
		return $count;

	}
	
	function increment_fail($new_count){


		$verno = $this->verify();

		if(! ($verno === true) || empty($new_count))
			return $verno;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        
        $new_count = mysql_real_escape_string($new_count);
		
        $del_sql = "delete from Config where config_key = 'login_fail_timestamp' or config_key = 'login_fail_count'";

        $db->execute($del_sql);
		
		$util = new Util();
		
		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','login_fail_timestamp', unix_timestamp())");

		$newkey = $util->gen_uuid();

		$db->execute("insert into Config (config_id,config_key,config_value) values ('" . $newkey . "','login_fail_count','" . $new_count . "')");
			
		$db->close();

		return true;

	}
	
	function reset_fail_count(){


		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

        $db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        
        $del_sql = "delete from Config where config_key = 'login_fail_timestamp' or config_key = 'login_fail_count'";

        $db->execute($del_sql);
		
		$db->close();

		return true;

	}
}
?>