<?php

include('db.class.php');
include('util.class.php');
include('aes.class.php');


class Base_Service
{
	protected $db_name;
	protected $db_host;
	protected $db_user;
	protected $db_password;


	public function __construct(){
		$ini = parse_ini_file("../config.php");

		$this->db_name = $ini["database_name"];
		$this->db_host = $ini["database_host"];
		$this->db_user = $ini["database_user"];
		$this->db_password = $ini["database_pwd"];

	}

	protected function verify(){
		if(! $this->verify_db())
			return 11;


		return true;
	}
	
	protected function verify_db(){
		if(empty($this->db_name))
			return false;

		if(empty($this->db_host))
			return false;

		if(empty($this->db_user))
			return false;

		if(empty($this->db_password))
			return false;

		return true;
	}

    protected function mysql_real_escape_array($t){
        if(empty($t))
            return null;
        return array_map("mysql_real_escape_string",$t);
    }

}
?>