<?php

class Context extends Base_Service
{


	function get($ctx_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$ctx_list = array();

		$sql = "select * from Context where ctx_id = '" . mysql_real_escape_string($ctx_id) . "'";

		$db->query($sql);
		
		while ($row = $db->fetchNextObject()) {
			$new_row = array("ctx_id" => $row->ctx_id, "ctx_name" => $row->ctx_name);
			array_push($ctx_list, $new_row);
		}
		
		$db->close();

		return $ctx_list;
		
	}

	function get_id_by_name($ctx_name){

    		$verno = $this->verify();

    		if(! ($verno === true))
    			return $verno;

    		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

    		//$ctx_list = array();

    		$sql = "select * from Context where ctx_name = '" . mysql_real_escape_string($ctx_name) . "'";

    		$db->query($sql);

            $result = false;

    		while ($row = $db->fetchNextObject()) {
    		    $result = $row->ctx_id;
    			break;
    		}

    		$db->close();

    		return $result;

    	}

	function add($ctx_name){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		

		$util = new UTIL();
		$new_id = $util->gen_uuid();
		
		$db->execute("insert into Context (ctx_id,ctx_name) values ('" . $new_id . "','" . mysql_real_escape_string($ctx_name) . "')");
		
		// Close the connexion to the base:
		$db->close();
		
		return $new_id;
	}
	
	function list_ctx(){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
		
		$ctx_list = array();
		
		$db->query("select * from Context order by ctx_name asc");
		
		while ($row = $db->fetchNextObject()) {
			$new_row = array("ctx_id" => $row->ctx_id, "ctx_name" => $row->ctx_name);
			array_push($ctx_list, $new_row);
		}
		
		$db->close();

		return $ctx_list;
		
	}
	
	function delete($ctx_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);
        $ctx_id = mysql_real_escape_string($ctx_id);

		// Check if context id existed
		$chk = $db->countOf("Context", "ctx_id = '" . $ctx_id . "'");

		if($chk == 0)
			return 12;
		
		//TODO Transaction need
		$db->execute("delete from Password_Context where ctx_id = '" . $ctx_id . "'");		
		$db->execute("delete from Context where ctx_id = '" . $ctx_id . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}
	
	function update($ctx_id,$ctx_name){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $ctx_id = mysql_real_escape_string($ctx_id);
        $ctx_name = mysql_real_escape_string($ctx_name);

		// Check if context id existed
		$chk = $db->countOf("Context", "ctx_id = '" . $ctx_id . "'");
		
		if($chk == 0)
			return 12;
			
		$db->execute("update Context set ctx_name = '" . $ctx_name . "' where ctx_id = '" . $ctx_id . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}


}
?>