<?php

class Password_Context extends Base_Service
{


    function isExisted($pwd_id,$ctx_id){
        $verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

        $chk = $db->countOf("Password_Context", "pwd_id = '" . mysql_real_escape_string($pwd_id) . "' and ctx_id = '" . mysql_real_escape_string($ctx_id) . "'");


    	if($chk > 0)
    		return true;
    	else
    	    return false;
    }
	function add($pwd_id,$ctx_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$pwd_id = mysql_real_escape_string($pwd_id);
		$ctx_id = mysql_real_escape_string($ctx_id);

		
		// Check if pwd id existed
		$chk = $db->countOf("Password", "pwd_id = '" . $pwd_id . "'");
		
		if($chk == 0)
			return 12;

		// Check if context id existed
		$chk = $db->countOf("Context", "ctx_id = '" . $ctx_id . "'");
		
		if($chk == 0)
			return 13;
		
		// Check for duplication first
		$chk = $db->countOf("Password_Context", "pwd_id = '" . $pwd_id . "' and ctx_id = '" . $ctx_id . "'");
		
		if($chk > 0)
			return 14;
		
		$util = new UTIL();
		$db->execute("insert into Password_Context (pc_id,pwd_id,ctx_id) values ('" . $util->gen_uuid() . "','" . $pwd_id . "','" . $ctx_id . "')");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}
	
	function list_ctx($pwd_id = '0'){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$ctx_list = array();
		
		$query_sql = "select pc.* from Password_Context pc";
		
		if(! empty($pwd_id) || $pwd_id == '0'){
			$query_sql .= " where pc.pwd_id = '" . mysql_real_escape_string($pwd_id) . "'";
		}


		$db->query($query_sql);
		
		while ($row = $db->fetchNextObject()) {
			$new_row = array("pc_id" => $row->pc_id, "pwd_id" => $row->pwd_id, "ctx_id" => $row->ctx_id);
			array_push($ctx_list, $new_row);
		}
		
		$db->close();

		return $ctx_list;
		
	}

	function delete($pwd_id,$ctx_id){
	
		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$db->execute("delete from Password_Context where pwd_id = '" . mysql_real_escape_string($pwd_id) . "' and ctx_id ='" . mysql_real_escape_string($ctx_id) . "'");
		
		// Close the connexion to the base:
		$db->close();
		
		return true;
	}

    function delete_all($pwd_id){

		$verno = $this->verify();

		if(! ($verno === true))
			return $verno;

		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

		$db->execute("delete from Password_Context where pwd_id = '" . mysql_real_escape_string($pwd_id) . "' ");

		// Close the connexion to the base:
		$db->close();

		return true;
	}

	function delete_by_name($pwd_id,$ctx_id){

    		$verno = $this->verify();

    		if(! ($verno === true))
    			return $verno;

    		$db = new DB($this->db_name,$this->db_host,$this->db_user,$this->db_password);

            $sql = "delete from Password_Context where pwd_id = '" . mysql_real_escape_string($pwd_id) . "'";
            $sql.= " and ctx_id in (";
            $sql.= "select b.ctx_id from Context b where b.ctx_name = '" . mysql_real_escape_string($ctx_id) . "'";
            $sql.= ")";


    		$db->execute($sql);

    		// Close the connexion to the base:
    		$db->close();

    		return true;
    	}
}
?>