<?php
//List Password
$app->post('/setup/gcm/reg', function () {

    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$config = new Config();

	$param = json_decode($json);

	$param_name = array('p','n','r','d');
	
	$login_result = login($param,$param_name);

	if($login_result === true){	
		$enc_key = get_encryption_key($param->{'p'});
		
		$result = true;
		
		if($config->is_lock_reg_id() == false){
			$result = $config->update_reg_id($enc_key,$param->{'r'}, $param->{d});
			if($result === true){
				if($config->is_email_reg_id()){
					$email = $config->get_gcm_email_reg_id();
					
	  
					$message = "The Registration ID is updated at " . date('Y-m-d H:i:s') . "\n\n";
					$message.= "The new Registration ID is " . $param->{'r'} . "\n\n";
					$message.= "The Device ID is " . $param->{'d'} . "\n\n";
					mail($email, 'Registration ID updated', $message);
				}
			}
		}

		if($result === true){
			
			$error = array('response' => 1, 'err_code' => 0);
		}else{
			$error = array('response' => 0, 'err_code' => 0, 'err_desc' => "Failed to register gcm.");
		}
	}else{

		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}
    echo json_encode($error);
});
?>