<?php
//List Password
$app->post('/setup/save', function () {

    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$config = new Config();

	$param = json_decode($json);

	if(
		empty($param->{'p'}) ||
		empty($param->{'k'})
	){
		missing_parameter();
		die;
	}


	$result = $config->save($param->{'p'},$param->{'k'});


	if($result === true){
	    $error = array('response' => 1, 'err_code' => 0, 'pwd_id' => $result);
	}else{

	    if($result == 11 || $result == "11")
	        $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Already configured');
	    else
            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Configuration failed');
     }
    echo json_encode($error);
});
?>