<?php
//List Password by Category ID
$app->post('/password/ctx/:id', function ($id) {

	sanitize($_GET,array('json' => 'str'));
    $json	= $_POST['json'];

    $error = array();

    check_json($json);

    $param = json_decode($json);

	$param_name = array('p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
	
		$offset = 0;
		$pageSize = 50;


		if(! empty($param->{'o'}))
			$offset = $param->{'o'};
		if(! empty($param->{'s'}))
            $pageSize = $param->{'s'};

		$enc_key = get_encryption_key($param->{'p'});

		push_password_view($enc_key, "Password retrieved " . $date = date('Y-m-d H:i:s'));
		
        $password = new Password();
        $result = $password->list_pwd_by_ctx($id,true,$enc_key);
        parse_result($result);
    }else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
        echo json_encode($error);
    }
});
?>