<?php
//Search Password
$app->post('/password/search', function () {

	sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];
	
	$error = array();

	check_json($json);
	
	$password = new Password();
	
	$param = json_decode($json);

	$param_name = array('kw','p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
		$enc_key = get_encryption_key($param->{'p'});
		
		push_password_view($enc_key, "Password searched " . $date = date('Y-m-d H:i:s'));
        
        $result = $password->search($param->{'kw'},true,$enc_key);
        parse_result($result);
    }else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
        echo json_encode($error);
    }
});
?>