<?php


//Add Password Context
$app->post('/password/:id/context', function ($id) {



	sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];
	
	$error = array();

	check_json($json);

	$context = new Password_Context();

	if(empty($id)){
		missing_parameter();
		die;
	}
	
	$param = json_decode($json);
	
	$param_name = array('ctx_id','p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){
		$result = $context->add($id,$param->{'ctx_id'});

		if($result === true)
			$error = array('response' => 1, 'err_code' => 0);
		else
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Add context to password failed');
	}else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}
	echo json_encode($error);
});
?>