<?php


//Add Password Context
$app->post('/password/:id/context/name', function ($id) {



	sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];
	
	$error = array();

	check_json($json);

	$pcontext = new Password_Context();

	if(empty($id)){
		missing_parameter();
		die;
	}
	
	$param = json_decode($json);
	
	$param_name = array('ctx_name','p','n');
	
	$login_result = login($param,$param_name);
	
	
	if($login_result === true){

        //check if ctx_name already existed, if not, create it
        $context = new Context();

        $ctx_id = $context->get_id_by_name($param->{'ctx_name'});
        if($ctx_id === FALSE){
            //not existed, create new context record
            $ctx_id = $context->add($param->{'ctx_name'});
        }else{
            //tag existed. skip if tag already attached to the password
            $isExisted = $pcontext->isExisted($id,$ctx_id);

            if($isExisted){
                $error = array('response' => 1, 'err_code' => 0);
                echo json_encode($error);
                die;
            }
        }

        $result = $pcontext->add($id,$ctx_id);

        if($result === true)
            $error = array('response' => 1, 'err_code' => 0, 'ctx_id' => $ctx_id);
        else
            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Add context to password failed');
    }else{
		$error = array('response' => 0, 'err_code' => $login_result, 'err_desc' => 'Nonce failed');
	}

	echo json_encode($error);
});
?>