<?php
//Generate initial key for two factor
$app->post('/two_factor_key/generate', function () {

    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$auth = new Auth();

	$param = json_decode($json);

	if(
		empty($param->{'p'})
	){
		missing_parameter();
		die;
	}

	$result = $auth->login($param->{'p'});


	if($result === true){
		$util = new UTIL();
		$init_key = $util->gen_ga_salt();
		
		$enc_key = get_encryption_key($param->{'p'});
	    $config = new Config();
		$result = $config->gen_2_factor_key($param->{'p'},$enc_key, $init_key);
		
		if($result === true)
			$error = array('response' => 1, 'err_code' => 0, 'key' => $init_key);
		else
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'Failed to generate 2 factor initial key');
	}else{

            $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'login failed');
     }
    echo json_encode($error);

});
?>